clang 8.0.0

Public Member Functions | Public Attributes | List of all members
clang::FunctionProtoType::ExtProtoInfo Struct Reference

Extra information about a function prototype. More...

`#include "clang/AST/Type.h"`

Collaboration diagram for clang::FunctionProtoType::ExtProtoInfo:
[legend]

## Public Member Functions
| ExtProtoInfo ()
| ExtProtoInfo (CallingConv CC)
ExtProtoInfo | withExceptionSpec (const ExceptionSpecInfo &ESI)

## Public Attributes
FunctionType::ExtInfo | ExtInfo
bool | Variadic: 1
bool | HasTrailingReturn: 1
Qualifiers | TypeQuals
RefQualifierKind | RefQualifier = RQ_None
ExceptionSpecInfo | ExceptionSpec
const ExtParameterInfo * | ExtParameterInfos = nullptr

## Detailed Description

Extra information about a function prototype.

ExtProtoInfo is not stored as such in FunctionProtoType but is used to group together the various bits of extra information about a function prototype.

Definition at line 3767 of file Type.h.

## Constructor & Destructor Documentation

## ◆ ExtProtoInfo() [1/2]

clang::FunctionProtoType::ExtProtoInfo::ExtProtoInfo | ( |  | ) |
| inline

Definition at line 3776 of file Type.h.

## ◆ ExtProtoInfo() [2/2]

clang::FunctionProtoType::ExtProtoInfo::ExtProtoInfo | ( | CallingConv | CC | ) |
| inline

Definition at line 3778 of file Type.h.

## Member Function Documentation

## ◆ withExceptionSpec()

ExtProtoInfo clang::FunctionProtoType::ExtProtoInfo::withExceptionSpec | ( | const ExceptionSpecInfo & | ESI | ) |
| inline

Definition at line 3781 of file Type.h.

References clang::EST_BasicNoexcept, clang::EST_DependentNoexcept, clang::EST_Dynamic, clang::EST_DynamicNone, clang::EST_MSAny, clang::EST_NoexceptFalse, clang::EST_NoexceptTrue, clang::EST_None, clang::EST_Unevaluated, clang::EST_Uninstantiated, clang::EST_Unparsed, ExceptionSpec, and clang::Result.

Referenced by clang::Sema::CheckEquivalentExceptionSpec().

## Member Data Documentation

## ◆ ExceptionSpec

ExceptionSpecInfo clang::FunctionProtoType::ExtProtoInfo::ExceptionSpec

Definition at line 3773 of file Type.h.

Referenced by clang::Sema::adjustCCAndNoReturn(), clang::Sema::AdjustDestructorExceptionSpec(), clang::Sema::FindCompositePointerType(), clang::ASTContext::GetBuiltinType(), clang::FunctionProtoType::getExtProtoInfo(), getImplicitMethodEPI(), clang::TemplateDeclInstantiator::InitFunctionInstantiation(), isCanonicalExceptionSpecification(), clang::FunctionProtoType::isTemplateVariadic(), LookupDirect(), clang::Sema::SubstExceptionSpec(), clang::QualType::substObjCTypeArgs(), clang::TreeTransform< Derived >::TransformFunctionProtoType(), clang::ASTNodeImporter::VisitFunctionProtoType(), and withExceptionSpec().

## ◆ ExtInfo

FunctionType::ExtInfo clang::FunctionProtoType::ExtProtoInfo::ExtInfo

Definition at line 3768 of file Type.h.

Referenced by clang::ASTContext::adjustFunctionType(), clang::Sema::FindCompositePointerType(), clang::ASTContext::GetBuiltinType(), clang::FunctionProtoType::getExtProtoInfo(), getImplicitMethodEPI(), clang::FunctionProtoType::isTemplateVariadic(), LookupDirect(), clang::ASTContext::mergeFunctionTypes(), clang::ASTContext::mergeObjCGCQualifiers(), and clang::ASTNodeImporter::VisitFunctionProtoType().

## ◆ ExtParameterInfos

const ExtParameterInfo* clang::FunctionProtoType::ExtProtoInfo::ExtParameterInfos = nullptr

Definition at line 3774 of file Type.h.

Referenced by clang::FunctionProtoType::getExtProtoInfo(), clang::FunctionProtoType::isTemplateVariadic(), clang::ASTContext::mergeFunctionTypes(), and clang::TreeTransform< Derived >::TransformFunctionProtoType().

## ◆ HasTrailingReturn

bool clang::FunctionProtoType::ExtProtoInfo::HasTrailingReturn

Definition at line 3770 of file Type.h.

Referenced by clang::Sema::ActOnBlockArguments(), clang::FunctionProtoType::getExtProtoInfo(), isCanonicalExceptionSpecification(), clang::FunctionProtoType::isTemplateVariadic(), and clang::ASTNodeImporter::VisitFunctionProtoType().

## ◆ RefQualifier

RefQualifierKind clang::FunctionProtoType::ExtProtoInfo::RefQualifier = RQ_None

Definition at line 3772 of file Type.h.

Referenced by clang::FunctionProtoType::getExtProtoInfo(), clang::FunctionProtoType::isTemplateVariadic(), and clang::ASTNodeImporter::VisitFunctionProtoType().

## ◆ TypeQuals

Qualifiers clang::FunctionProtoType::ExtProtoInfo::TypeQuals

Definition at line 3771 of file Type.h.

Referenced by clang::Sema::ActOnBlockArguments(), clang::Sema::CheckFunctionTemplateSpecialization(), clang::FunctionProtoType::getExtProtoInfo(), clang::FunctionProtoType::isTemplateVariadic(), and clang::ASTNodeImporter::VisitFunctionProtoType().

## ◆ Variadic

bool clang::FunctionProtoType::ExtProtoInfo::Variadic

Definition at line 3769 of file Type.h.

Referenced by clang::Sema::CheckDestructorDeclarator(), clang::ASTContext::GetBuiltinType(), clang::FunctionProtoType::getExtProtoInfo(), clang::FunctionProtoType::isTemplateVariadic(), and clang::ASTNodeImporter::VisitFunctionProtoType().

The documentation for this struct was generated from the following file:

- include/clang/AST/Type.h